package com.objis.spring.demo;

import org.apache.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;

import com.objis.spring.demo.SocieteDevLogiciel;

@Configuration
public class DemoAppJavaConfig {

	private static final Logger logger = Logger.getLogger(DemoApp.class);

	public static void main(String[] args) {

		// 1. Chargement du conteneur en 4.0.0 Spring
		ApplicationContext appContext = new AnnotationConfigApplicationContext(DemoAppJavaConfig.class);
		// 2. Recuperation d'un bean du conteneur
		SocieteDevLogiciel societe = (SocieteDevLogiciel) appContext.getBean(SocieteDevLogiciel.class);

		// 3. Manipulation du bean avec injection de dependances
		logger.info("Chef Developpeur: " + societe.getChefDeveloppeur().getNom());
		logger.info("Developpeur     : " + societe.getDeveloppeur().getNom());
	}

	
	@Bean
	public SocieteDevLogiciel societeDevLogiciel() {
        return new SocieteDevLogiciel(developpeur(),chefDeveloppeur());
    }

	@Bean
	public Developpeur developpeur() {
        return new Developpeur("Olivier", 7);
    }

	@Bean
	public Developpeur chefDeveloppeur() {
        return new Developpeur("Franck", 10);
    }

}
